#include "StdAfx.h"
#include "EraseCountGraph.h"
#include "JSLogger.h"
#include "boost/tuple/tuple.hpp"
#include "LifeSpanEstimation.h"

using namespace std;

CEraseCountGraph::CEraseCountGraph(void){

	_hFontHor = CreateFont(14, //tHg
		0, //
		0, //eLXg̊px
		0, //x[XCƂƂ̊px
		FW_REGULAR, //tHg̏di
		FALSE, //C^bN 
		FALSE, //A_[C 
		FALSE, //ł 
		DEFAULT_CHARSET, //Zbg 
		OUT_DEFAULT_PRECIS, //o͐x 
		CLIP_DEFAULT_PRECIS,//NbsOx 
		DEFAULT_QUALITY, //o͕i 
		DEFAULT_PITCH | FF_DONTCARE,//sb`ƃt@~[ 
		_T("Arial")); 
	_hFontVer = CreateFont(12, //tHg
		0, //
		200, //eLXg̊px
		0, //x[XCƂƂ̊px
		FW_REGULAR, //tHg̏di
		FALSE, //C^bN 
		TRUE, //A_[C 
		FALSE, //ł 
		ANSI_CHARSET, //Zbg 
		OUT_DEFAULT_PRECIS, //o͐x 
		CLIP_DEFAULT_PRECIS,//NbsOx 
		PROOF_QUALITY, //o͕i 
		DEFAULT_PITCH | FF_DONTCARE,//sb`ƃt@~[ 
		_T("Times New Roman")); 
	_hFontTEC = CreateFont(24, //tHg
		0, //
		0, //eLXg̊px
		0, //x[XCƂƂ̊px
		FW_BOLD, //tHg̏di
		FALSE, //C^bN 
		FALSE, //A_[C 
		FALSE, //ł 
		ANSI_CHARSET, //Zbg 
		OUT_DEFAULT_PRECIS, //o͐x 
		CLIP_DEFAULT_PRECIS,//NbsOx 
		DEFAULT_QUALITY, //o͕i 
		DEFAULT_PITCH | FF_DONTCARE,//sb`ƃt@~[ 
		_T("Times New Roman")); 
	_hFontTEC2 = CreateFont(20, //tHg
		0, //
		0, //eLXg̊px
		0, //x[XCƂƂ̊px
		FW_BOLD, //tHg̏di
		FALSE, //C^bN 
		FALSE, //A_[C 
		FALSE, //ł 
		ANSI_CHARSET, //Zbg 
		OUT_DEFAULT_PRECIS, //o͐x 
		CLIP_DEFAULT_PRECIS,//NbsOx 
		DEFAULT_QUALITY, //o͕i 
		DEFAULT_PITCH | FF_DONTCARE,//sb`ƃt@~[ 
		_T("Times New Roman")); 

	_nLastDriveNo = -1;

	_dXMinMin   = 0;
	_dXMinMax   = 365*50;
	_dXRangeMin = 0.1;
	_dXRangeMax = 365*25;
	_dYMinMin   = 0;
	_dYMinMax   = 1000000;
	_dYRangeMin = 10;
	_dYRangeMax = 1000000;
	_bDragging = false;
}

CEraseCountGraph::~CEraseCountGraph(void){
	DeleteObject(_hFontHor);
	DeleteObject(_hFontVer);
	DeleteObject(_hFontTEC);
	DeleteObject(_hFontTEC2);
}

std::pair<int, int> CEraseCountGraph::GetScreenPos(double dX, double dY) {
	return make_pair((int)round((dX-_dXMin)/_dXRange*_nGraphWidth)+_nGraphXMin, 
										_nGraphHeight-(int)round((dY-_dYMin)/_dYRange*_nGraphHeight)+_nGraphYMin);
}

void CEraseCountGraph::DrawCross(HDC hdcGraph, double dx, double dy, int nSize, COLORREF col, bool bScreenPos) {

	int x, y;
	if (bScreenPos) {
		x = (int)dx;
		y = (int)dy;
	}
	else {
		boost::tie(x,y) = GetScreenPos(dx, dy);
	}
	int n1 = (nSize-1)/2;
//	if ( (_nGraphXMin < x-n1) && (_nGraphXMin+_nGraphWidth > x+n1+1) && (_nGraphYMin < y-n1) && (_nGraphYMin+_nGraphHeight > y+n1+1) ) {
	if ( (_nGraphXMin < x) && (_nGraphXMin+_nGraphWidth > x) && (_nGraphYMin < y) && (_nGraphYMin+_nGraphHeight >= y) ) {
		HPEN hPen = CreatePen(PS_SOLID, 1, col);
		SelectObject(hdcGraph, hPen);
		int nXMin = max(x-n1,   _nGraphXMin);
		int nXMax = min(x+n1+1, _nGraphXMin+_nGraphWidth);
		int nYMin = max(y-n1,   _nGraphYMin);
		int nYMax = min(y+n1+1, _nGraphYMin+_nGraphHeight);
		MoveToEx(hdcGraph, nXMin, y, NULL);
		LineTo(hdcGraph, nXMax, y);
		MoveToEx(hdcGraph, x, nYMin, NULL);
		LineTo(hdcGraph, x, nYMax);
		DeleteObject(hPen); 
	}
}

void CEraseCountGraph::DrawRules(HDC hdcGraph) {

  HPEN hPen = CreatePen(PS_DOT, 1, RGB(64,64,64));

	//rƐl`
	SelectObject(hdcGraph, hPen);
	SetTextColor(hdcGraph, RGB(0,0,0));
	const int _nRuleIntervalScrHeight = 20;
	const int _nRuleIntervalScrWidth  = 35;
	const int _nRuleIntervalMinHeight = 100;  //100񂨂
	const int _nRuleIntervalMinWidth  = 1;   //1
	double dIntervalScrWidth  = _nRuleIntervalMinWidth /_dXRange*_nGraphWidth;
	double dIntervalScrHeight = _nRuleIntervalMinHeight/_dYRange*_nGraphHeight;
	int nX1=1;
	while (dIntervalScrWidth*nX1 < _nRuleIntervalScrWidth) ++nX1;
	dIntervalScrWidth *= nX1;
	int nX2=1;
	while (dIntervalScrHeight*nX2 < _nRuleIntervalScrHeight) ++nX2;
	dIntervalScrHeight *= nX2;
	int nIntervalX = _nRuleIntervalMinWidth*nX1;
	int nIntervalY = _nRuleIntervalMinHeight*nX2;
	double dYMin = nIntervalY*ceil(_dYMin/nIntervalY); 
	double dFirstY = _nGraphHeight-((dYMin-_dYMin)/_dYRange*_nGraphHeight);
	double dXMin = nIntervalX*floor(_dXMin/nIntervalX); //
	double dFirstX = ((dXMin-_dXMin)/_dXRange*_nGraphWidth)+dIntervalScrWidth;

	//
	int nOldAlign = SetTextAlign(hdcGraph, TA_BASELINE|TA_RIGHT);
	int nOldBkMode = SetBkMode(hdcGraph,TRANSPARENT);
	SelectObject(hdcGraph, _hFontHor);
	int nCount = 0; wchar_t aBuf[20];
	for (double dY= dFirstY; dY>=0; dY-=dIntervalScrHeight, ++nCount) {
		int nY = (int)round(dY);
		MoveToEx(hdcGraph, _nGraphXMin, _nGraphYMin+nY, NULL);
		LineTo(hdcGraph, _nGraphXMin+_nGraphWidth, _nGraphYMin+nY);
		int nLabel = (int)(dYMin + nCount*nX2*_nRuleIntervalMinHeight);
		_itow_s(nLabel, aBuf, 20, 10);
		TextOut(hdcGraph, _nGraphXMin, _nGraphYMin+nY+6, aBuf, wcslen(aBuf));
	}

	//
	SetTextAlign(hdcGraph, TA_TOP|TA_RIGHT);
	nCount = 1;
	SelectObject(hdcGraph, _hFontVer);
	for (double dX=dFirstX;  dX<=_nGraphWidth;  dX+=dIntervalScrWidth, ++nCount) {
		int nX = (int)round(dX);
		MoveToEx(hdcGraph, _nGraphXMin+nX, _nGraphYMin, NULL);
		LineTo(hdcGraph, _nGraphXMin+nX, _nGraphYMin+_nGraphHeight);
		int nDay = (int)(dXMin + nCount*nX1*_nRuleIntervalMinWidth);
		SDate date(nDay);
		wstring s1 = boost::gregorian::to_iso_extended_wstring(date.dPtime.date());
		TextOut(hdcGraph, _nGraphXMin+nX-4, _nGraphYMin+_nGraphHeight, s1.c_str(), s1.length());
		RECT rc = {nX,_nGraphHeight,0,0};
	}

	//ݎ
	COLORREF lblue2 = RGB(0x67,0xBA,0xC3);
	COLORREF lblue = RGB(0x00,0x81,0xB8);	
  HPEN hCTimePenD = CreatePen(PS_DOT, 1, lblue2);
	HPEN hCTimePen = CreatePen(PS_SOLID, 1, lblue2);
	SelectObject(hdcGraph, hCTimePenD);	
	SelectObject(hdcGraph, _hFontHor);
	SetTextColor(hdcGraph, lblue);
	SDate Current(boost::posix_time::second_clock::local_time());
	int nX, nY;
	boost::tie(nX,nY) = GetScreenPos(Current.dDayFromEpoch, 0);
	if ((_nGraphXMin <= nX) && (nX < _nGraphXMin+_nGraphWidth)) {
		MoveToEx(hdcGraph, nX, _nGraphYMin, NULL);
		LineTo(hdcGraph, nX, _nGraphYMin+_nGraphHeight);
		wstring s1 = _T("now");
		RECT rect = {0, 0, 0, 0};
		if (nX < _nGraphXMin+_nGraphWidth-30) {
			SelectObject(hdcGraph, hCTimePen);
			MoveToEx(hdcGraph, nX, _nGraphYMin+_nGraphHeight, NULL);
			LineTo(hdcGraph, nX+10, _nGraphYMin+_nGraphHeight-10);
			SetTextAlign(hdcGraph, nOldAlign);
			DrawText(hdcGraph, s1.c_str(), s1.length(), &rect, DT_LEFT|DT_SINGLELINE|DT_CALCRECT);
			rect.top += _nGraphYMin+_nGraphHeight-15;
			rect.bottom += _nGraphYMin+_nGraphHeight-15;
			rect.left += nX+10;
			rect.right += nX+10;
			Rectangle(hdcGraph, rect.left-2, rect.top, rect.right+2, rect.bottom);
			DrawText(hdcGraph, s1.c_str(), s1.length(), &rect, DT_LEFT|DT_SINGLELINE);
		}
		else {
		}
	}

	SetTextColor(hdcGraph, RGB(0,0,0));
	DeleteObject(hPen); 
	DeleteObject(hCTimePenD); 
	DeleteObject(hCTimePen); 
}

void CEraseCountGraph::DrawLine(HDC hdcGraph, double dA, double dB, COLORREF col) {

	if ((dA==-1 && dB==-1) || (dA == 0)) return;

	double dX0 = _dXMin;
	double dX1 = _dXMin+_dXRange-(_dXRange/_nGraphWidth);
	double dY0 = dA*dX0+dB;
	double dY1 = dA*dX1+dB;

	if ((dY0 > _dYMin+_dYRange) && (dY1 > _dYMin+_dYRange)) return;
	if ((dY0 < _dYMin) && (dY1 < _dYMin)) return;

	int nX0, nY0, nX1, nY1;
	boost::tie(nX0, nY0) = GetScreenPos(dX0, dY0);
	boost::tie(nX1, nY1) = GetScreenPos(dX1, dY1);

	if (nY1 < _nGraphYMin) {
		double dY12 = _dYMin+_dYRange;
		double dX12 = (dY12-dB)/dA;
		boost::tie(nX1, nY1) = GetScreenPos(dX12, dY12);
	}
	if (nY0 > _nGraphYMin+_nGraphHeight) {
		double dY02 = _dYMin;
		double dX02 = (dY02-dB)/dA;
		boost::tie(nX0, nY0) = GetScreenPos(dX02, dY02);
	}

  HPEN hPen = CreatePen(PS_SOLID, 1, col);
	SelectObject(hdcGraph, hPen);
	MoveToEx(hdcGraph, nX1, nY1, NULL);
	LineTo(hdcGraph, nX0, nY0);
	DeleteObject(hPen);
}

void CEraseCountGraph::DrawLegend(HDC hdcGraph, int nx, int ny) {

	RECT rect = {nx,ny,nx+100,ny+30};
	HPEN hPen = CreatePen(PS_SOLID, 1, RGB(128,128,128));
	HBRUSH hBrush = (HBRUSH)GetStockObject(WHITE_BRUSH);
	SelectObject(hdcGraph, hPen);
	SelectObject(hdcGraph, hBrush);	
	SelectObject(hdcGraph, _hFontHor);
	SetTextAlign(hdcGraph, TA_TOP|TA_LEFT);
	Rectangle(hdcGraph, nx, ny, nx+124, ny+28);

	DrawCross(hdcGraph, nx+6, ny+6, 5, RGB(255,0,0), true);
	DrawCross(hdcGraph, nx+6, ny+18, 5, RGB(0,255,0), true);

	SelectObject(hdcGraph, (HBRUSH)GetStockObject(BLACK_BRUSH));	
	wchar_t c1[] = _T(":Maximum Erase Count");
	wchar_t c2[] = _T(":Average Erase Count");
	TextOut(hdcGraph, nx+10, ny, c1, wcslen(c1));
	TextOut(hdcGraph, nx+10, ny+12, c2, wcslen(c2));
	DeleteObject(hPen);
}

bool CEraseCountGraph::StartMouseDrag(int x, int y, bool bLeft) {
	if ( (_nGraphXMin < x) && (x < _nGraphXMin+_nGraphWidth) &&
			 (_nGraphYMin < y) && (y < _nGraphYMin+_nGraphHeight)) {				
		_nXDragBegin = x;
		_nYDragBegin = y;
		_bDragging = true;
		return true;
	}
	else _bDragging = false;
	return false;
}

bool CEraseCountGraph::MouseDrag(int x, int y, bool bLeft) {

	if (_bDragging && 
		 (_nGraphXMin < x) && (x < _nGraphXMin+_nGraphWidth) &&
		 (_nGraphYMin < y) && (y < _nGraphYMin+_nGraphHeight)) 
	{
		int nXSa = _nXDragBegin-x;
		int nYSa = _nYDragBegin-y;
		double nX1 = _dXRange/_nGraphWidth;
		double nY1 = _dYRange/_nGraphHeight;

		if (bLeft) {
			_dXMin += nXSa*nX1;
			_dYMin -= nYSa*nY1;
			_dXMin = min(max(_dXMinMin, _dXMin), _dXMinMax);
			_dYMin = min(max(_dYMinMin, _dYMin), _dYMinMax);
		}
		else {
			//S𓯂ꏊ̂܂܂ɂ
			double dXCenter = _dXMin + _dXRange/2;
			double dYCenter = _dYMin + _dYRange/2;
			_dXRange += nXSa*nX1;
			_dYRange += nYSa*nY1;
			_dXRange = min(max(_dXRangeMin, _dXRange), _dXRangeMax);
			_dYRange = min(max(_dYRangeMin, _dYRange), _dYRangeMax);
			_dXMin = dXCenter - _dXRange/2;
			_dYMin = dYCenter - _dYRange/2;
			_dXMin = min(max(_dXMinMin, _dXMin), _dXMinMax);
			_dYMin = min(max(_dYMinMin, _dYMin), _dYMinMax);
		}
		_nXDragBegin = x;
		_nYDragBegin = y;

		return true;
	}
	else {
		StartMouseDrag(x,y,bLeft);
	}
	return false;
}

void CEraseCountGraph::ResetScale() {
	_nLastDriveNo = -1;
	_nLastLogNo = 0;
}


void CEraseCountGraph::DrawGraph(HDC hdcGraph, const RECT& rSize, const CJSLogger &rLogger, size_t nDriveNo, bool bUseMax) {

	const std::vector<SDate> &rvDateLog = rLogger.GetDateLog(nDriveNo);
	const std::vector<unsigned int> &rvAveEraseLog = rLogger.GetAveEraseLog(nDriveNo);
	const std::vector<unsigned int> &rvMaxEraseLog = rLogger.GetMaxEraseLog(nDriveNo);

	_nGraphXMin=36;
	_nGraphYMin=27;
	_nGraphWidth  = rSize.right-rSize.left-_nGraphXMin-4;
	_nGraphHeight = rSize.bottom-rSize.top-_nGraphYMin-35;

	if (((nDriveNo != _nLastDriveNo) || (rvDateLog.size() != _nLastLogNo) )&& (!rvDateLog.empty())) {
		
		double dDateMin = rvDateLog.front().dDayFromEpoch;
		SDate Current(boost::posix_time::second_clock::local_time());
		double dDateMax = Current.dDayFromEpoch;

		unsigned int nAveMin = rvAveEraseLog.front();
		unsigned int nAveMax = rvAveEraseLog.back();
		unsigned int nMaxMin = rvMaxEraseLog.front();
		unsigned int nMaxMax = rvMaxEraseLog.back();

		int _nXYobun = 36; //pixel
		double _dYYobun = 50;
		//]̈vZ
		double d1 = (dDateMax-dDateMin)/_nGraphWidth;
		double dXYobun = max(1.0, d1*_nXYobun);
		_dXMin = floor(dDateMin - dXYobun);
		double dXMax = ceil(dDateMax + dXYobun);
		_dXRange = dXMax - _dXMin;

		_dYMin   = max(0.0, 100*floor((nAveMin-_dYYobun)/100.0));
		double dYMax = 100*ceil((nMaxMax+_dYYobun)/100.0);
		_dYRange = dYMax - _dYMin;
	}
	_nLastDriveNo = nDriveNo;
	_nLastLogNo = rvDateLog.size();

	//
	const CLifeSpanEstimation::SLifeSpanResult *psResultMax;
	const CLifeSpanEstimation::SLifeSpanResult *psResultAve;
	const std::vector<int> *pMaxUsedList;
	const std::vector<int> *pAveUsedList;

	boost::tie(psResultMax, pMaxUsedList) = rLogger.GetLSEResult(nDriveNo, true);
	boost::tie(psResultAve, pAveUsedList) = rLogger.GetLSEResult(nDriveNo, false);
	
	//wiFɓh
	HBRUSH hBGBrush = CreateSolidBrush(GetSysColor(COLOR_3DFACE));
	SelectObject(hdcGraph, GetStockObject(NULL_PEN));
	SelectObject(hdcGraph, hBGBrush);
	Rectangle(hdcGraph, rSize.left, rSize.top, rSize.right, rSize.bottom);
	DeleteObject(hBGBrush);

	//nɓh
	SelectObject(hdcGraph, GetStockObject(WHITE_PEN));
	SelectObject(hdcGraph, GetStockObject(WHITE_BRUSH));
	Rectangle(hdcGraph, _nGraphXMin, _nGraphYMin, _nGraphXMin+_nGraphWidth, _nGraphYMin+_nGraphHeight);

	//r`
	DrawRules(hdcGraph);

	//`
	DrawLine(hdcGraph, psResultMax->dValuePerDay, psResultMax->dValueAtEpoch, RGB(255,128,128));
	DrawLine(hdcGraph, psResultAve->dValuePerDay, psResultAve->dValueAtEpoch, RGB(128,255,128));

	//f[^`
	for (size_t i=0; i<rvDateLog.size(); ++i) {
		std::pair<int, int> Pos1 = GetScreenPos(rvDateLog[i].dDayFromEpoch, rvAveEraseLog[i]);
		std::pair<int, int> Pos2 = GetScreenPos(rvDateLog[i].dDayFromEpoch, rvMaxEraseLog[i]);
		if (pAveUsedList->at(i) == 1) {
			DrawCross(hdcGraph, rvDateLog[i].dDayFromEpoch, rvAveEraseLog[i], 5, RGB(150,255,150));
		}
		else if (pAveUsedList->at(i) == 2) {
			DrawCross(hdcGraph, rvDateLog[i].dDayFromEpoch, rvAveEraseLog[i], 7, RGB(0,255,0));
		}
		if (pMaxUsedList->at(i) == 1) {
			DrawCross(hdcGraph, rvDateLog[i].dDayFromEpoch, rvMaxEraseLog[i], 5, RGB(255,150,150));
		}
		else if (pMaxUsedList->at(i) == 2) {
			DrawCross(hdcGraph, rvDateLog[i].dDayFromEpoch, rvMaxEraseLog[i], 7, RGB(255,0,0));
		}
	}

	//}`
	DrawLegend(hdcGraph, _nGraphXMin+5, _nGraphYMin+5);

	//`
	const CLifeSpanEstimation::SLifeSpanResult *pResult;
	if (bUseMax) pResult = psResultMax;
	else pResult = psResultAve;
	wstring sDate;
	if (pResult->dTEC.date() == GetEpoch()) {
		sDate = _T("unavailable");
	}
	else {
		sDate = boost::gregorian::to_iso_extended_wstring(pResult->dTEC.date());
		sDate[4] = sDate[7] = '/';
	}
	HPEN hPen = CreatePen(PS_SOLID, 1, RGB(128,128,128));
	HBRUSH hBrush = (HBRUSH)GetStockObject(NULL_BRUSH);
	SelectObject(hdcGraph, hPen);
	SelectObject(hdcGraph, hBrush);	
	SetTextAlign(hdcGraph, TA_TOP|TA_LEFT);

	wostringstream oss; oss << "TEC: " << sDate;
	RECT rect1 = {0,0,0,0};
	SelectObject(hdcGraph, _hFontTEC);
	DrawText(hdcGraph, oss.str().c_str(), oss.str().length(), &rect1,DT_LEFT|DT_SINGLELINE|DT_CALCRECT);

	double dDriveSize = CJSSmart::GetInstance().GetSSDStatus()[nDriveNo]->GetStatus()->nDriveSize/1000.0/1000.0/1000.0;
	wostringstream oss2; oss2<< " (" << setiosflags(ios::fixed)  << setprecision(1) << pResult->dValuePerDay*dDriveSize << "GB/day";
	const CIDXStatus *pTarget = dynamic_cast<const CIDXStatus*>(CJSSmart::GetInstance().GetSSDStatus()[nDriveNo]->GetStatus());
	if (pTarget) {
		oss2 << ", " << pTarget->nRemainingDriveLife << "%";
	}
	oss2 << ")";
	RECT rect2 = {0,0,0,0};
	SelectObject(hdcGraph, _hFontTEC2);
	DrawText(hdcGraph, oss2.str().c_str(), oss2.str().length(), &rect2 ,DT_LEFT|DT_SINGLELINE|DT_CALCRECT);

	int xOffset = ((rSize.right-rSize.left)-((rect1.right-rect1.left)+(rect2.right-rect2.left)))/2;
	int X1 = rect1.right-rect1.left;
	int Y1 = rect1.bottom-rect1.top;
	int X2 = rect2.right-rect2.left;
	int Y2 = rect2.bottom-rect2.top;
	rect1.right+=xOffset;
	rect1.left+=xOffset;
	rect2.right+=(xOffset+X1);
	rect2.left+=(xOffset+X1);
	rect2.bottom+=(Y1-Y2-2);
	rect2.top+=(Y1-Y2-2);
	SelectObject(hdcGraph, _hFontTEC);
	DrawText(hdcGraph, oss.str().c_str(), oss.str().length(), &rect1, DT_LEFT|DT_SINGLELINE);
	SelectObject(hdcGraph, _hFontTEC2);
	DrawText(hdcGraph, oss2.str().c_str(), oss2.str().length(), &rect2, DT_LEFT|DT_SINGLELINE);
	rect1.left -= 10; rect1.right += (10+(rect2.right-rect2.left));
	Rectangle(hdcGraph, rect1.left, rect1.top, rect1.right, rect1.bottom);

	DeleteObject(hPen);
}
