#pragma once

#include "JSLogger.h"
#include "windows.h"


class CEraseCountGraph
{
public:
	CEraseCountGraph(void);
	virtual ~CEraseCountGraph(void);

	void DrawGraph(HDC hdcGraph, const RECT& rSize, const CJSLogger &rLogger, size_t nDriveNo, bool bUseMax);
	bool StartMouseDrag(int x, int y, bool bLeft);
	bool MouseDrag(int x, int y, bool bLeft);
	void ResetScale();

protected:

	std::pair<int, int> GetScreenPos(double dX, double dY);
	void DrawCross(HDC hdcGraph, double dx, double dy, int nSize, COLORREF col, bool bScreenPos=false);
	void DrawRules(HDC hdcGraph);
	void DrawLine(HDC hdcGraph, double dA, double dB, COLORREF col);
	void DrawLegend(HDC hdcGraph, int nx, int ny);

	double _dXMin;
	double _dXRange;
	double _dYMin;
	double _dYRange;

	double _dXMinMin;
	double _dXMinMax;
	double _dXRangeMin;
	double _dXRangeMax;
	double _dYMinMin;
	double _dYMinMax;
	double _dYRangeMin;
	double _dYRangeMax;

	int _nGraphXMin;
	int _nGraphYMin;
	int _nGraphWidth;
	int _nGraphHeight;
	int _nLastDriveNo;
	size_t _nLastLogNo;

	HFONT _hFontHor;
	HFONT _hFontVer;
	HFONT _hFontTEC;
	HFONT _hFontTEC2;

	int _nXDragBegin;
	int _nYDragBegin;

	bool _bDragging;
};
