#pragma once
#include "observer.h"
#include "windows.h"
#include "JSSmart.h"
#include <list>


class CJSAlert :
	public CObserver<CJSSmart>
{
public:

	enum EAlertType{
		eNoAlert = 0,
		eBalloon = 1,
		eDialog = 2,
	};
	static CJSAlert &GetInstance();
	virtual ~CJSAlert(void);
	virtual void Notify(const CJSSmart& rSubject);
	void SetHWND(HWND hWnd) {_hWnd = hWnd;}
	//vOJƂɒlςĂۂɂxo悤ɂ邽߂̉
	void SetLastAttributes(const std::vector<boost::shared_ptr<CJSStatus> >& rvLastAttribute);
	const std::vector<std::string>& GetBalloonAlerts() const {return _vBalloonAlerts;}
	const std::vector<std::string>& GetDialogAlerts() const {return _vDialogAlerts;}
	const std::vector<std::string>& GetAllAlerts() const {return _vAllAlerts;}
	void SetBalloonAlerts(const std::vector<std::string>& rv) {_vBalloonAlerts = rv;}
	void SetDialogAlerts(const std::vector<std::string>& rv) {_vDialogAlerts = rv;}
	
protected:

	CJSAlert(void);
	HWND _hWnd;
	std::vector<boost::shared_ptr<CJSStatus> >  _vLastAttribute;
	bool _bFirst;
	void ShowAlert(EAlertType eType, const std::wstring &rTitle, const std::wstring &rMessage);

	std::vector<std::string> _vBalloonAlerts;
	std::vector<std::string> _vDialogAlerts;
	std::vector<std::string> _vAllAlerts;

	std::list<HANDLE> _lDialogs;
};
