#pragma once

#include "JSSmart.h"

class CJSIDXStatus : public CJSStatus
{
public:
	CJSIDXStatus(const CIDXStatus *pStatus) {
		_IDXStatus = *pStatus;
	}
	virtual ~CJSIDXStatus(void) {}

	virtual void AddStatusDetailString(std::ostream &os, bool bHideSerial) const;
	virtual void UpdateSSDDialog(std::vector<HWND>& rvSmartDialogs, bool bHideSerial) const;
	virtual bool IsUpdated(const CJSStatus* rStatus) const;
	virtual std::string WriteToCSV() const;
	virtual bool ReadFromCSV(const std::string &rsLine);
	virtual std::string MakeCSVHeader() const;
	virtual std::string GetStatusChangeString(const CJSStatus* pOldStatus, const std::vector<std::string> &vTargetStrings) const;
	virtual int GetEraseCountMax() const;

	virtual const CSSDStatus *GetStatus() const {return &_IDXStatus;}
	virtual boost::shared_ptr<CJSStatus> MakeClone() const;

protected: 

	unsigned long long GetValueWithKeyword(const std::string &rKey) const;
	CIDXStatus _IDXStatus;
};