#pragma once

#include "JSSmart.h"

class CJSJMFStatus : public CJSStatus
{
public:
	CJSJMFStatus(const CJMFStatus* pStatus) {
		_JMFStatus = *pStatus;
	}
	virtual ~CJSJMFStatus(void) {}

	virtual void AddStatusDetailString(std::ostream &os, bool bHideSerial) const;
	virtual void UpdateSSDDialog(std::vector<HWND>& rvSmartDialogs, bool bHideSerial) const;
	virtual bool IsUpdated(const CJSStatus* rStatus) const;
	virtual std::string WriteToCSV() const;
	virtual bool ReadFromCSV(const std::string &rsLine);
	virtual std::string MakeCSVHeader() const;
	virtual std::string GetStatusChangeString(const CJSStatus* pOldStatus, const std::vector<std::string> &vTargetStrings) const;
	virtual int GetEraseCountMax() const;

	virtual const CSSDStatus *GetStatus() const {return &_JMFStatus;}
	virtual boost::shared_ptr<CJSStatus> MakeClone() const;

	bool ReadStatusFromOldLog (std::istream &is);
protected:
	CJMFStatus _JMFStatus;
};
