#pragma once
#include <vector>

#include "JSSmart.h"
#include "Observer.h"
#include "fstream"
#include <boost/shared_ptr.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>
#include "LifeSpanEstimation.h"
const boost::gregorian::date& GetEpoch();
double ptime2date(const boost::posix_time::ptime &rTime);
boost::posix_time::ptime date2ptime(double dDate);

struct SDate{
	SDate(double dDate) {
		dDayFromEpoch = dDate;
		dPtime = date2ptime(dDate);
	}
	SDate(const boost::posix_time::ptime& rptime) {
		dPtime = rptime;
		dDayFromEpoch = ptime2date(rptime);
	}
	double dDayFromEpoch; //2008/1/1̌oߓŕ\
	boost::posix_time::ptime dPtime; //ۑE\p
};

//Oۑ+茋ʂ̎擾
class CJSLogger : public CObserver<CJSSmart>
{
public:
	static CJSLogger &GetInstance();
	virtual ~CJSLogger(void);

	virtual void Notify(const CJSSmart& rSubject);

	//vOJƂɒlςĂۂɂxo悤ɂ邽߂̉
	const std::vector<boost::shared_ptr<CJSStatus> >& GetLastAttributes() const {return _vpLastSSDStatus;}

	std::pair<const CLifeSpanEstimation::SLifeSpanResult *, const std::vector<int> *> GetLSEResult(size_t nDriveNum, bool bUseMax) const;
	CLifeSpanEstimation &GetLSE() {ResetNeedCalc(); return _LSE;}
	const CLifeSpanEstimation &GetLSE() const {return _LSE;}
	void ReadLog(const CJSSmart& rSubject);

	const std::vector<SDate> &GetDateLog(size_t n) const {return _vDateTimeLog[n];}
	const std::vector<unsigned int> &GetAveEraseLog(size_t n) const {return _vnAveEraseLog[n];}
	const std::vector<unsigned int> &GetMaxEraseLog(size_t n) const {return _vnMaxEraseLog[n];}
	const std::vector<boost::shared_ptr<CJSStatus> >& GetLastSSDStatus() const {return  _vpLastSSDStatus;}

protected:
	CJSLogger(void);
	void UpdateLog(const CJSSmart& rSubject);
	void ResetNeedCalc() {
		for (size_t i=0;i<_vbNeedRecalcLSE.size(); ++i) _vbNeedRecalcLSE[i] = true;
	}
	bool ReadFromOldLog(const CJSStatus* pStatus);

	bool _bLogOpened;
	CLifeSpanEstimation _LSE;
	std::vector<boost::shared_ptr<std::ofstream> > _vLogFiles;
	std::vector<std::vector<SDate> > _vDateTimeLog;
	std::vector<std::vector<unsigned int> > _vnAveEraseLog;
	std::vector<std::vector<unsigned int> > _vnMaxEraseLog;
	std::vector<CSSDStatus::EFlashType> _vSSDType; //MLC or SLC
	mutable std::vector<bool> _vbNeedRecalcLSE; //KvȂƂČvZ
	mutable std::vector<CLifeSpanEstimation::SLifeSpanResult> _vsMaxResult;
	mutable std::vector<CLifeSpanEstimation::SLifeSpanResult> _vsAveResult;
	mutable std::vector<std::vector<int> > _vnMaxUsedList;
	mutable std::vector<std::vector<int> > _vnAveUsedList;

	std::vector<boost::shared_ptr<CJSStatus> > _vpLastSSDStatus;
//	bool OpenOldLog();
};
