#include "StdAfx.h"
#include "JSLogger.h"
#include "LifeSpanEstimation.h"

using namespace std;

CLifeSpanEstimation::CLifeSpanEstimation(void)
{
	_nLimitType = 1;
	_nLimitNum = 100;
	_nLimitDay = 30;
}

CLifeSpanEstimation::~CLifeSpanEstimation(void)
{
}

//pvUsedList -> size=vLogƓA0=XVȂ, 1=͈͊O, 2=gp
//ŏ@pĎ
CLifeSpanEstimation::SLifeSpanResult CLifeSpanEstimation::GetLifeSpan(const std::vector<SDate> &vDateLog, const std::vector<unsigned int> &vECLog, 
																																			unsigned int nMaxNum, std::vector<int> *pvUsedList) const
{
	if ( vDateLog.empty() || (vDateLog.size() != vECLog.size()))  {
//		throw std::exception("GetLifeSpan vDateLog.size() != vECLog.size()");
		SLifeSpanResult s1 = {0, 0, date2ptime(0)};
		return s1;
	}

	pvUsedList->resize(vDateLog.size());
	fill(pvUsedList->begin(), pvUsedList->end(), 1);

	double B=0, C=0, D=0, E=0;
	if (vDateLog.size() < 4) {
		SLifeSpanResult s1 = {0, 0, date2ptime(0)};
		return s1;
	}
	size_t n=0;
	size_t nPos = vDateLog.size()-1;
	boost::posix_time::ptime CurrentTime = boost::posix_time::second_clock::local_time();
	SDate LastDate(CurrentTime);
	double firstx = LastDate.dDayFromEpoch;
	double x = vDateLog[nPos].dDayFromEpoch;
	double y = vECLog[nPos];
	pvUsedList->at(0) = 1;
	for (; nPos != 0; --nPos) {
		double nextx = vDateLog[nPos-1].dDayFromEpoch;
		double nexty = vECLog[nPos-1];
		if (nexty != y) {
			if ((_nLimitType == 0) || ((_nLimitType == 1) && (n < (size_t)_nLimitNum)) || ((_nLimitType == 2) && ( (firstx-x) < _nLimitDay))) {
				B+=x*x;
				C+=y;
				D+=x*y;
				E+=x;
				++n;
				pvUsedList->at(nPos) = 2;
			}
			else pvUsedList->at(nPos) = 1;
		}
		else pvUsedList->at(nPos) = 0;
		x = nextx;
		y = nexty;
	}

	if (n < 3) {
		SLifeSpanResult s1 = {0, 0, date2ptime(0)};
		return s1;
	}

	//y=ax+b;
	double a = (n*D-C*E)/(n*B-E*E);
	double b = (B*C-D*E)/(n*B-E*E);
	double dEoL = ((double)(nMaxNum)-b)/a;

	SLifeSpanResult s1 = {a, b, date2ptime(dEoL)};
	return s1;
}
