#pragma once

#include <vector>
#include <boost/variant.hpp>
#include <string>

class CRegistrySetting {
public:
	CRegistrySetting ();
	virtual ~CRegistrySetting ();

	virtual bool Open(HKEY hRoot, const std::wstring& sPos, const std::wstring& sKey);

	typedef boost::variant<DWORD,std::wstring,std::vector<std::wstring> > ValueType;
	const ValueType& GetCurrentValue() const {return _valCurrent;}
	DWORD GetValueType() const {return _nValueType;}
	bool SetValue(ValueType value);

	const std::wstring &GetPos() const {return _sPos;}
	const std::wstring &GetKey() const {return _sKey;}
	bool RemoveValue();

protected:

	CRegistrySetting (const CRegistrySetting &r) { *this = r; }
	CRegistrySetting& operator = (const CRegistrySetting &r) {_hKey = NULL;}

	HKEY _hKey;
	DWORD _nValueType;
	ValueType _valCurrent;
	HKEY _hRoot;
	std::wstring _sPos;
	std::wstring _sKey;
};


class CRegistrySettingWithCheckButton : public CRegistrySetting {
public:
	CRegistrySettingWithCheckButton():CRegistrySetting() {};
	virtual ~CRegistrySettingWithCheckButton () {};
	bool Open(HKEY hRoot, const std::wstring& sPos, const std::wstring& sKey, DWORD nType, 
						const CRegistrySetting::ValueType &valOKState, const CRegistrySetting::ValueType &valNGState, bool bNotExistState);
	bool GetStatus() const {return _bStatus;}
	bool SetStatus(bool bStatus);
protected:
	CRegistrySetting::ValueType _valOKState;
	CRegistrySetting::ValueType _valNGState;
	bool _bStatus;
	bool _bNotExistState; //GgȂꍇ̏ԂɂȂ 

};