#pragma once

#include <wbemidl.h>
#include <winioctl.h>
#include <windows.h>
#include <string>
#include <stdio.h>
#include <sstream>
#include "OutputDebugStream.h"

//http://www.usefullcode.net/2007/02/hdd.html ꕔ]

class	CDnpATAPI
{
protected:

	enum	IO_CONTROL_CODE
	{
		DFP_RECEIVE_DRIVE_DATA	= 0x0007c088,
	};

	enum	ATAPI_COMMAND_CODE
	{
		ATAPI_IDENTIFY_DEVICE	= 0xEC,
		ATAPI_SMART_READ_DATA	= 0xB0,
	};


#pragma pack(push,1)

	struct	IDENTIFY_DEVICE_OUTDATA
	{
		SENDCMDOUTPARAMS	sSendCmdOutParam;
		BYTE	pData[IDENTIFY_BUFFER_SIZE - 1];
	};

	struct	SMART_READ_DATA_OUTDATA
	{
		SENDCMDOUTPARAMS	sSendCmdOutParam;
		BYTE	pData[READ_ATTRIBUTE_BUFFER_SIZE - 1];
	};


	typedef	struct	_DRIVEATTRIBUTE {
		BYTE	bAttrID;		// Identifies which attribute
		WORD	wStatusFlags;	// see bit definitions below
		union {
			struct {
				BYTE	bAttrValue;		// Current normalized value
				BYTE	bWorstValue;	// How bad has it ever been?
				BYTE	bRawValue[6];	// Un-normalized value
				BYTE	bReserved;		// ...
			};
			BYTE bData[9];
		};
	} DRIVEATTRIBUTE, *PDRIVEATTRIBUTE, *LPDRIVEATTRIBUTE;

public:
	//
	//	IDENTIFY_DEVICE̎擾ʍ\
	//
	struct IDENTIFY_DEVICE
	{
		USHORT	wGeneralConfiguration;		//0			//15bit:0=ATAfoCXA7bit:1=[oufBAEfoCX
		USHORT	wObsolute1;					//1
		USHORT	wSpecificConfiguration;		//2
		USHORT	wObsolute2;					//3
		USHORT	wRetired1[2];				//4-5
		USHORT	wObsolute3;					//6
		ULONG	ulReservedForCompactFlash;	//7-8
		USHORT	wRetired2;					//9
		CHAR	pszSerialNumber[20];		//10-19		//VAio[
		ULONG	ulRetired3;					//20-21
		USHORT	wObsolute4;					//22
		CHAR	pszFirmwareRev[8];			//23-26		//t@[EGAEo[W
		CHAR	pszModelNumber[40];			//27-46		//f
		USHORT	wMaxNumPerInterupt;			//47
		USHORT	wReserved1;					//48
		USHORT	wCapabilities1;				//49		//8bit:1=DMAΉ@9bit:1=LBAΉ@10bit:1=IORDY@11bit:1=IORDYΉ/0=s
		USHORT	wCapabilities2;				//50
		ULONG	ulObsolute5;				//51-52
		USHORT	wField88and7063;			//53		//2bit:1=88[hڏ񗘗p\@1bit:1=70:64[hڏ񗘗p\
		USHORT	wObsolute6[5];				//54-58
		USHORT	wMultSectorStuff;			//59
		ULONG	ulTotalAddressableSectors;	//60-61
		USHORT	wObsolute7;					//62
		USHORT	wMultiWordDMA;				//63		//0bit:1=mode0Ή@1bit:1=mode1Ή@2bit:1=mode2Ή@8bit:1=mode0I@9bit:mode1I@10bit:mode2I
		USHORT	wPIOMode;					//64
		USHORT	wMinMultiwordDMACycleTime;	//65
		USHORT	wRecommendedMultiwordDMACycleTime;	//66
		USHORT	wMinPIOCycleTimewoFlowCtrl;	//67
		USHORT	wMinPIOCycleTimeWithFlowCtrl;	//68
		USHORT	wReserved2[6];				//69-74
		USHORT	wQueueDepth;				//75
		USHORT	wReserved3[4];				//76-79
		USHORT	wMajorVersion;				//80		//4bit:1=ATA/ATAPI-4Ή@5bit:1=ATA/ATAPI-5Ή@6bit:1=ATA/ATAPI-6Ή@7bit:1=ATA/ATAPI-7Ή
		USHORT	wMinorVersion;				//81
		USHORT	wCommandSetSupported1;		//82		//0bit:1=SMARTΉ@1bit:SecurityModeΉ@....
		USHORT	wCommandSetSupported2;		//83		//0bit:1=DOWNLOAD MicrocodeΉ@....
		USHORT	wCommandSetSupported3;		//84		//0bit:1=SMART error loggingΉ@1bit:1=SMART self-testΉ@....
		USHORT	wCommandSetEnable1;			//85		//0bit:1=SMARTp\@....
		USHORT	wCommandSetEnable2;			//86		//0bit:1=DOWNLOAD Microcodep\@....
		USHORT	wCommandSetDefault;			//87
		USHORT	wUltraDMAMode;				//88		//0bit:1=UltraDMAmode0Ή@1bit:1=UltraDMAmode1Ή@....
		USHORT	wTimeReqForSecurityErase;	//89
		USHORT	wTimeReqForEnhancedSecure;	//90
		USHORT	wCurrentPowerManagement;	//91
		USHORT	wMasterPasswordRevision;	//92
		USHORT	wHardwareResetResult;		//93
		USHORT	wAcoustricmanagement;		//94
		USHORT	wStreamMinRequestSize;		//95
		USHORT	wStreamingTimeDMA;			//96
		USHORT	wStreamingAccessLatency;	//97
		ULONG	ulStreamingPerformance;		//98-99
		USHORT	pwMaxUserLBA[4];			//100-103
		USHORT	wStremingTimePIO;			//104
		USHORT	wReserved4;					//105
		USHORT	wSectorSize;				//106
		USHORT	wInterSeekDelay;			//107
		USHORT	wIEEEOUI;					//108
		USHORT	wUniqueID3;					//109
		USHORT	wUniqueID2;					//110
		USHORT	wUniqueID1;					//111
		USHORT	wReserved5[4];				//112-115
		USHORT	wReserved6;					//116
		ULONG	ulWordsPerLogicalSector;	//117-118
		USHORT	wReserved7[8];				//119-126
		USHORT	wRemovableMediaStatus;		//127
		USHORT	wSecurityStatus;			//128
		USHORT	pwVendorSpecific[31];		//129-159
		USHORT	wCFAPowerMode1;				//160
		USHORT	wReserved8[15];				//161-175
		CHAR	pszCurrentMediaSerialNo[60];//176-205
		USHORT	wReserved9[49];				//206-254
		USHORT	wIntegrityWord;				//255		//0-7bit:Signature@8-15bit:Checksum
	};
#pragma	pack(pop)


protected:

	//
	//	т̐`
	//
	VOID ChangeByteOrder(PCHAR szString, USHORT uscStrSize)
	{
		USHORT	i;
		CHAR	temp;

		for(i = 0; i < uscStrSize; i+=2)
		{
			temp = szString[i];
			szString[i] = szString[i+1];
			szString[i+1] = temp;
		}
		for (i = uscStrSize-1; i>0; --i) {
			if ((szString[i]==' ')  && (szString[i-1]!=' '))  {
				szString[i]='\0';
				return;
			}
		}
	}

	//
	//	DeviceIoControl֓nnh̎擾
	//
	bool	GetIoCtrlHandle(HANDLE* phIoCtrl,int nDeviceNo)
	{
		HANDLE	hIoCtrl;

		if(phIoCtrl == NULL) return	false;
		*phIoCtrl = INVALID_HANDLE_VALUE;
		std::wstringstream ss; ss << "\\\\.\\PhysicalDrive" << nDeviceNo;
		hIoCtrl = ::CreateFile(ss.str().c_str(),GENERIC_READ | GENERIC_WRITE,FILE_SHARE_READ | FILE_SHARE_WRITE,NULL,OPEN_EXISTING,0,NULL);
		if(hIoCtrl == INVALID_HANDLE_VALUE)
			return	false;
		*phIoCtrl = hIoCtrl;

		return	true;
	}



public:


	class	CSmartAttribute
	{
		BYTE	_pAttributeData[READ_ATTRIBUTE_BUFFER_SIZE];

		DRIVEATTRIBUTE*	_ppInfo[30];


	public:
		CSmartAttribute()
		{
			Init();
		}

		void	Init(void)
		{
			::ZeroMemory(_pAttributeData,READ_ATTRIBUTE_BUFFER_SIZE);
			::ZeroMemory(_ppInfo,sizeof(DRIVEATTRIBUTE*) * 30);
		}

		bool	SetData(const BYTE* pData,int cbSize)
		{
			if(cbSize != READ_ATTRIBUTE_BUFFER_SIZE)
				return	false;

			Init();
			memcpy(_pAttributeData,pData,READ_ATTRIBUTE_BUFFER_SIZE);

			int		i;
			DRIVEATTRIBUTE**	ppInfo;
			DRIVEATTRIBUTE*		pAttribute;

			ppInfo = _ppInfo;
			pAttribute = (DRIVEATTRIBUTE*)&(_pAttributeData[2]);
			for(i = 0; i < 30; i++)
			{
				if(pAttribute->bAttrID)
				{
					*ppInfo = pAttribute;
					ppInfo++;
				}
				pAttribute++;
			}
			return	true;
		}
		bool	GetAttributeCount(int* pnCount) const
		{
			int		i;

			if(pnCount == NULL)
				return	false;

			*pnCount = 0;
			for(i = 0; i < 30; i++)
			{
				if(_ppInfo[i] && _ppInfo[i]->bAttrID == 0)
					break;
				(*pnCount)++;
			}
			return	true;
		}
		bool	GetAttribute(int nIndex,BYTE* pcbAttrID,WORD* pwFlags,BYTE* pcbValue,BYTE* pcbWorstValue,BYTE pcbRawValue[6],BYTE* pcbReserved) const
		{
			if(nIndex < 0 || nIndex > 30 || _ppInfo[nIndex] == NULL || _ppInfo[nIndex]->bAttrID == 0)
				return	false;

			if(pcbAttrID)
				*pcbAttrID = _ppInfo[nIndex]->bAttrID;
			if(pwFlags)
				*pwFlags = _ppInfo[nIndex]->wStatusFlags;
			if(pcbValue)
				*pcbValue = _ppInfo[nIndex]->bAttrValue;
			if(pcbWorstValue)
				*pcbWorstValue = _ppInfo[nIndex]->bWorstValue;
			if(pcbRawValue)
				memcpy(pcbRawValue,_ppInfo[nIndex]->bRawValue,6);
			if(pcbReserved)
				*pcbReserved = _ppInfo[nIndex]->bReserved;

			return	true;
		}
		bool	GetAttribute(int nIndex,BYTE* pcbAttrID, BYTE* pcbData) const{
			if(nIndex < 0 || nIndex > 30 || _ppInfo[nIndex] == NULL || _ppInfo[nIndex]->bAttrID == 0)
				return	false;
			if(pcbAttrID)
				*pcbAttrID = _ppInfo[nIndex]->bAttrID;
			if(pcbData)
				memcpy(pcbData, _ppInfo[nIndex]->bData, 9);
			return	true;
		}
	};


	bool EnableSmart(int nDriveNo) {
		BOOL	bRet;
		HANDLE	hIoCtrl;
		DWORD	dwReturned;

		SENDCMDINPARAMS		sendCmd;
		SENDCMDOUTPARAMS	sendCmdOutParam;

		if(!GetIoCtrlHandle(&hIoCtrl, nDriveNo))
		{
//			dout << "GetIoCtrlHandle Failed2!" << std::endl;
			return false;
		}

		::ZeroMemory(&sendCmd, sizeof(SENDCMDINPARAMS));
		::ZeroMemory(&sendCmdOutParam, sizeof(SENDCMDOUTPARAMS));

		sendCmd.irDriveRegs.bFeaturesReg	= ENABLE_SMART;
		sendCmd.irDriveRegs.bSectorCountReg = 1;
		sendCmd.irDriveRegs.bSectorNumberReg= 1;
		sendCmd.irDriveRegs.bCylLowReg		= SMART_CYL_LOW;
		sendCmd.irDriveRegs.bCylHighReg		= SMART_CYL_HI;
		sendCmd.irDriveRegs.bCommandReg		= SMART_CMD;
		sendCmd.cBufferSize					= 0;

		bRet = ::DeviceIoControl(hIoCtrl, 0x0007C084, 
			&sendCmd, sizeof(SENDCMDINPARAMS) - 1,
			&sendCmdOutParam, sizeof(SENDCMDOUTPARAMS) -1,
			&dwReturned, NULL);

		::CloseHandle(hIoCtrl);
		if (bRet == FALSE) {
			dout << "EnableSmart Failed!" << std::endl;
			return false;
		}
		return true;
	}

	bool GetSmartCmdOutParam(SMART_READ_DATA_OUTDATA& sSendCmdOutParam, int nDeviceNo) {

		HANDLE	hIoCtrl;

		//nh擾
		bool ret = GetIoCtrlHandle(&hIoCtrl,nDeviceNo);
		if(ret == false) {
			dout << "GetIoCtrlHandle Failed!" << std::endl;
			return	false;
		}

		SENDCMDINPARAMS	sSendCmd;
		::ZeroMemory(&sSendCmdOutParam,sizeof(SMART_READ_DATA_OUTDATA));
		::ZeroMemory(&sSendCmd,sizeof(SENDCMDINPARAMS));
		/*
		//orig
		sSendCmd.irDriveRegs.bFeaturesReg	= 0xd0;
		sSendCmd.irDriveRegs.bCylLowReg		= 0x4f;
		sSendCmd.irDriveRegs.bCylHighReg	= 0xc2;
		sSendCmd.irDriveRegs.bDriveHeadReg	= 0xA0 | ((nDeviceNo & 1) << 4);	//hCuԍ
		sSendCmd.irDriveRegs.bCommandReg	= ATAPI_SMART_READ_DATA;			//SMART READ DATAR}hԍ
		sSendCmd.cBufferSize	= READ_ATTRIBUTE_BUFFER_SIZE;
		sSendCmd.bDriveNumber	= nDeviceNo;			//hCuԍ
		*/
		sSendCmd.irDriveRegs.bFeaturesReg	= READ_ATTRIBUTES;
		sSendCmd.irDriveRegs.bSectorCountReg = 1;
		sSendCmd.irDriveRegs.bSectorNumberReg= 1;
		sSendCmd.irDriveRegs.bCylLowReg		= SMART_CYL_LOW;
		sSendCmd.irDriveRegs.bCylHighReg		= SMART_CYL_HI;
		sSendCmd.irDriveRegs.bCommandReg		= SMART_CMD;
		sSendCmd.cBufferSize					= READ_ATTRIBUTE_BUFFER_SIZE;
		//R}h̎s
		DWORD	dwReturned;
		BOOL bRet = ::DeviceIoControl(hIoCtrl,DFP_RECEIVE_DRIVE_DATA,&sSendCmd,sizeof(SENDCMDINPARAMS),&sSendCmdOutParam,sizeof(SMART_READ_DATA_OUTDATA),&dwReturned,NULL);
		::CloseHandle(hIoCtrl);
		if(ret == FALSE) {
			dout << "GetSmartCmdOutParam Failed : ret==FALSE" << std::endl;			
			return	false;
		}
		if (dwReturned != sizeof(SMART_READ_DATA_OUTDATA)) {
			dout << "GetSmartCmdOutParam Failed : dwReturned=" << dwReturned << std::endl;			
			return	false;
		}
		return true;
	}

	//
	//	SMART擾
	//
	bool	GetSmartReadData(int nDeviceNo,CSmartAttribute* pInfo)
	{
		SMART_READ_DATA_OUTDATA	sSendCmdOutParam;

		if(pInfo == NULL) return	false;
		pInfo->Init();
		if (!GetSmartCmdOutParam(sSendCmdOutParam, nDeviceNo)) {
			if (!EnableSmart(nDeviceNo) || (!GetSmartCmdOutParam(sSendCmdOutParam, nDeviceNo))) {
				dout << "Retry Failed." << std::endl;
				return false;
			}
		}
		return	pInfo->SetData(sSendCmdOutParam.sSendCmdOutParam.bBuffer,READ_ATTRIBUTE_BUFFER_SIZE);
	}

	class	CModelInfo
	{
	public:
		std::string	_strModel;
		std::string	_strFirmware;
		std::string	_strSerialNo;
	};
	//
	//	foCX擾
	//
	bool	GetIdentifyDevice(int nDeviceNo,IDENTIFY_DEVICE* pData,CModelInfo* pInfo=NULL)
	{
		bool	ret;
		BOOL	bRet;
		HANDLE	hIoCtrl;
		DWORD	dwReturned;
		IDENTIFY_DEVICE_OUTDATA	sSendCmdOutParam;
		SENDCMDINPARAMS	sSendCmd;

		if(pData == NULL)
			return	false;
		::ZeroMemory(pData,sizeof(IDENTIFY_DEVICE));
		if(pInfo)
			*pInfo = CModelInfo();

		//nh擾
		ret = GetIoCtrlHandle(&hIoCtrl,nDeviceNo);
		if(ret == false)
			return	false;
		::ZeroMemory(&sSendCmdOutParam,sizeof(IDENTIFY_DEVICE_OUTDATA));
		::ZeroMemory(&sSendCmd,sizeof(SENDCMDINPARAMS));
		sSendCmd.irDriveRegs.bCommandReg		= ATAPI_IDENTIFY_DEVICE;			//IDENTIFY DEVICER}hԍ
		sSendCmd.irDriveRegs.bDriveHeadReg		= 0xA0 | ((nDeviceNo & 1) << 4);	//hCuԍ
		sSendCmd.cBufferSize	= IDENTIFY_BUFFER_SIZE;
		sSendCmd.bDriveNumber	= nDeviceNo;			//hCuԍ

		//IDENTIFY DEVICER}h̎s
		bRet = ::DeviceIoControl(hIoCtrl,DFP_RECEIVE_DRIVE_DATA,&sSendCmd,sizeof(SENDCMDINPARAMS),&sSendCmdOutParam,sizeof(IDENTIFY_DEVICE_OUTDATA),&dwReturned,NULL);
		::CloseHandle(hIoCtrl);
		if(ret == FALSE || dwReturned != sizeof(IDENTIFY_DEVICE_OUTDATA))
			return	false;

		memcpy_s(pData,sizeof(IDENTIFY_DEVICE),sSendCmdOutParam.sSendCmdOutParam.bBuffer,sizeof(IDENTIFY_DEVICE));

		if(pInfo)
		{
			char pszBuff[256];
			char *p;
//			IDENTIFY_DEVICE*	pData;
//			pData = (IDENTIFY_DEVICE*)sSendCmdOutParam.sSendCmdOutParam.bBuffer;
			ChangeByteOrder(pData->pszModelNumber,sizeof(pData->pszModelNumber));
			ChangeByteOrder(pData->pszFirmwareRev,sizeof(pData->pszFirmwareRev));
			ChangeByteOrder(pData->pszSerialNumber,sizeof(pData->pszSerialNumber));
			strncpy_s(pszBuff,256,pData->pszModelNumber,sizeof(pData->pszModelNumber));
			p=pszBuff; while ((*p == ' ') || (*p == '\0')) ++p;
			pInfo->_strModel = p;
			strncpy_s(pszBuff,256,pData->pszFirmwareRev,sizeof(pData->pszFirmwareRev));
			p=pszBuff; while ((*p == ' ') || (*p == '\0')) ++p;
			pInfo->_strFirmware = p;
			strncpy_s(pszBuff,256,pData->pszSerialNumber,sizeof(pData->pszSerialNumber));
			p=pszBuff; while ((*p == ' ') || (*p == '\0')) ++p;
			pInfo->_strSerialNo = p;
		}
		return	true;
	}
};
