#pragma once

#include <list>

template <class T>
class CObserver
{
public:

	CObserver(void){}
	virtual ~CObserver(void) {}
	virtual void Notify(const T& rSubject) = 0;
};

template <class T>
class CSubject
{
public:
	CSubject(void){};
	~CSubject(void){};

	size_t AddObserver(CObserver<T>* pObserver) {
		_vpObservers.push_back(pObserver);
		return _vpObservers.size()-1;
	}
	void RemoveObserver(size_t n) {
		if (_vpObservers.size() > n) {
			std::list<CObserver<T>*>::iterator it=_vpObservers.begin();
			it+=n;
			_vpObservers.erase(it);
		}
	}
	const std::list<CObserver<T>*>& GetObservers() const {return _vpObservers;}

protected:

	void NotifyObservers(const T& pData) {		
		for (std::list<CObserver<T>*>::iterator it=_vpObservers.begin();it != _vpObservers.end(); ++it) {
			(*it)->Notify(pData);
		}
	}

	std::list<CObserver<T>*> _vpObservers;
};