#pragma once

#ifdef _MSC_VER

#include <windows.h>
#include <iostream>

template <class Ch,class Tr=std::char_traits<Ch> >
class basic_outputdebug_streambuf : public std::basic_streambuf<Ch,Tr> {
public:
	basic_outputdebug_streambuf(void){}
	~basic_outputdebug_streambuf(void){}

protected:
  int overflow( int nCh = EOF ) {
		_buffer.append(1,(char)nCh);
		return 0;
  }
	int sync() {
		OutputDebugStringA(_buffer.c_str());
		_buffer.clear();
		return 0;
	}
private:
	std::string _buffer;
};

template <class Ch,class Tr=std::char_traits<Ch> >
class basic_outputdebug_stream : public std::basic_ostream<Ch,Tr>{

public:
  ~basic_outputdebug_stream(void){}
	static basic_outputdebug_stream & getInstance() {
		static basic_outputdebug_stream singleton;
		return singleton;
	}
private:
	basic_outputdebug_stream(void)
		: std::basic_ostream<Ch,Tr>(new basic_outputdebug_streambuf<Ch,Tr>()) {}
};

typedef basic_outputdebug_streambuf<char> outputdebug_streambuf;
typedef basic_outputdebug_stream<char> outputdebug_stream;

#define dout (outputdebug_stream::getInstance())

#else

#define dout cerr

#endif
