#include "SSDSmartUtil.h"
#include <sstream>
#include <shlwapi.h>
#include <tchar.h>

#pragma comment(lib, "shlwapi.lib")
using namespace std;

std::wstring widen(const std::string& input) {
	wchar_t* buffer = new wchar_t[input.size()+1];
	size_t convertedChars = 0;
	mbstowcs_s(&convertedChars, buffer, input.size()+1, input.c_str(), input.size());
	std::wstring result = buffer;
	delete[] buffer;
	return result;
}

std::string narrow(const std::wstring &input) {
	char* buffer = new char[input.size()*2+1];
  size_t convertedChars = 0;
	wcstombs_s(&convertedChars, buffer, input.size()*2+1, input.c_str(), input.size()*2);
	std::string result = buffer;
	delete[] buffer;	
	return result;
}

bool RegisterStartup(const wchar_t* sAppName)
{
	OSVERSIONINFOEX osvi = {0};
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if (!GetVersionEx((OSVERSIONINFO *)&osvi)) return false;

	wchar_t path[MAX_PATH];
	GetModuleFileName(NULL, path, MAX_PATH);
	wstringstream ss;
	if(osvi.dwMajorVersion >= 6)
	{
		STARTUPINFO si = {0};
		PROCESS_INFORMATION pi = {0};
		si.cb			= sizeof(STARTUPINFO);
		si.dwFlags		= STARTF_USESHOWWINDOW;
		si.wShowWindow	= SW_HIDE;
		ss <<  _T("schtasks.exe /Create /tn ") << sAppName << _T(" /tr \"'") << path << _T("' /Startup\" /sc ONLOGON /RL HIGHEST /F");
		::CreateProcess(NULL, (LPWSTR)ss.str().c_str(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
		WaitForSingleObject(pi.hProcess, 1000);
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}
	else
	{
		HKEY hKey;
		DWORD disposition;
		LONG result;
		result = ::RegCreateKeyEx(HKEY_CURRENT_USER, 
			_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), 0, _T(""),
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &disposition);
		if(result == ERROR_SUCCESS)
		{
			ss << _T("\"") << path << _T("\" /Startup");
			::RegSetValueEx(hKey, sAppName, 0, REG_SZ,
				(CONST BYTE*)(LPCTSTR)ss.str().c_str(),
				((DWORD)ss.str().size() + 3) * 2);
			::RegCloseKey(hKey);
		}
	}
	return true;
}

bool UnregisterStartup(const wchar_t* sAppName)
{
	OSVERSIONINFOEX osvi = {0};
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if (!GetVersionEx((OSVERSIONINFO *)&osvi)) return false;

	if(osvi.dwMajorVersion >= 6)
	{
		STARTUPINFO si = {0};
		PROCESS_INFORMATION pi = {0};
		si.cb			= sizeof(STARTUPINFO);
		si.dwFlags		= STARTF_USESHOWWINDOW;
		si.wShowWindow	= SW_HIDE;
		wstringstream ss;
		ss << _T("schtasks.exe /Delete /tn ") << sAppName << _T(" /F") ;
		::CreateProcess(NULL, (LPWSTR)ss.str().c_str(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
		WaitForSingleObject(pi.hProcess, 1000);
		CloseHandle(pi.hThread);
		CloseHandle(pi.hProcess);
	}
	else
	{
		HKEY hKey;
		DWORD disposition;
		LONG result;
		result = ::RegCreateKeyEx(HKEY_CURRENT_USER, 
			_T("Software\\Microsoft\\Windows\\CurrentVersion\\Run"), 0, _T(""),
			REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hKey, &disposition);
		if(result == ERROR_SUCCESS)
		{
			::RegDeleteValue(hKey, sAppName);
			::RegCloseKey(hKey);
		}
	}
	return true;
}

wstring GetModulePath() {

	wchar_t sTemp[MAX_PATH];
	GetModuleFileName(NULL, sTemp, MAX_PATH);
	PathRemoveFileSpec(sTemp);
	return wstring(sTemp);
}

bool IsOSWinXP() {
	OSVERSIONINFOEX osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if (GetVersionEx((LPOSVERSIONINFO)&osvi)) {
		if ((osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion == 1)) return true; //32bit
		if ((osvi.dwMajorVersion == 5) && (osvi.dwMinorVersion == 2) && (osvi.wProductType == VER_NT_WORKSTATION)) return true; //64bit
	}
	return false;
}

bool IsOSVista() {
	OSVERSIONINFOEX osvi;
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if (GetVersionEx((LPOSVERSIONINFO)&osvi))
		if (osvi.dwMajorVersion >= 6) return true;
	return false;
}


std::wstring GetLastErrorString(DWORD dwErrorNo)
{
	LPVOID lpMsgBuf = NULL;
	if( (0==FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER |
		FORMAT_MESSAGE_FROM_SYSTEM |
		FORMAT_MESSAGE_IGNORE_INSERTS|FORMAT_MESSAGE_MAX_WIDTH_MASK,
		NULL,
		dwErrorNo,
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
		(LPWSTR)&lpMsgBuf,
		0,
		NULL)) || lpMsgBuf==NULL )
	{
		return _T("");
	}
 	wstring rsResult = (LPTSTR)lpMsgBuf;
	LocalFree(lpMsgBuf);  
	return rsResult;
 
}

BOOL SetDlgItemULLWithComma(HWND hDlg, int nIDDlgItem, unsigned long long nValue) {
	ostringstream oss;
	oss.imbue(std::locale(""));
	oss << nValue;
	return SetDlgItemTextA(hDlg, nIDDlgItem, oss.str().c_str());
}
